---
title: transform
slug: Web/CSS/transform
tags:
  - CSS
  - CSS Property
  - Reference
  - Transforms
  - 'recipe:css-property'
---
<div>{{CSSRef}}</div>

<p>The <strong><code>transform</code></strong> <a href="/en-US/docs/Web/CSS">CSS</a> property lets you rotate, scale, skew, or translate an element. It modifies the coordinate space of the CSS <a href="/en-US/docs/Web/CSS/Visual_formatting_model">visual formatting model</a>.</p>

<div>{{EmbedInteractiveExample("pages/css/transform.html")}}</div>

<p>If the property has a value different than <code>none</code>, a <a href="/en-US/docs/Web/CSS/CSS_Positioning/Understanding_z_index/The_stacking_context">stacking context</a> will be created. In that case, the element will act as a <a href="/en-US/docs/Web/CSS/Containing_block">containing block</a> for any <code>position: fixed;</code> or <code>position: absolute;</code> elements that it contains.</p>

<div class="warning">
<p>Only transformable elements can be <code>transform</code>ed. That is, all elements whose layout is governed by the CSS box model except for: <a href="/en-US/docs/Web/CSS/Visual_formatting_model#Inline-level_elements_and_inline_boxes">non-replaced inline boxes</a>, <a href="/en-US/docs/Web/HTML/Element/col">table-column boxes</a>, and <a href="/en-US/docs/Web/HTML/Element/colgroup">table-column-group boxes</a>.</p>
</div>

<h2 id="Syntax">Syntax</h2>

<pre class="brush: css notranslate">/* Keyword values */
transform: none;

/* Function values */
transform: matrix(1.0, 2.0, 3.0, 4.0, 5.0, 6.0);
transform: matrix3d(1, 0, 0, 0, 0, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, 1);
transform: perspective(17px);
transform: rotate(0.5turn);
transform: rotate3d(1, 2.0, 3.0, 10deg);
transform: rotateX(10deg);
transform: rotateY(10deg);
transform: rotateZ(10deg);
transform: translate(12px, 50%);
transform: translate3d(12px, 50%, 3em);
transform: translateX(2em);
transform: translateY(3in);
transform: translateZ(2px);
transform: scale(2, 0.5);
transform: scale3d(2.5, 1.2, 0.3);
transform: scaleX(2);
transform: scaleY(0.5);
transform: scaleZ(0.3);
transform: skew(30deg, 20deg);
transform: skewX(30deg);
transform: skewY(1.07rad);

/* Multiple function values */
transform: translateX(10px) rotate(10deg) translateY(5px);
transform: perspective(500px) translate(10px, 0, 20px) rotateY(3deg);

/* Global values */
transform: inherit;
transform: initial;
transform: unset;
</pre>

<p>The <code>transform</code> property may be specified as either the keyword value <code><a href="#none">none</a></code> or as one or more <code><a href="#&lt;transform-function&gt;">&lt;transform-function&gt;</a></code> values.</p>

<p>If {{cssxref("transform-function/perspective", "perspective()")}} is one of multiple function values, it must be listed first.</p>

<h3 id="Values">Values</h3>

<dl>
 <dt id="&lt;transform-function&gt;">{{cssxref("&lt;transform-function&gt;")}}</dt>
 <dd>One or more of the <a href="/en-US/docs/Web/CSS/transform-function">CSS transform functions</a> to be applied. The transform functions are multiplied in order from left to right, meaning that composite transforms are effectively applied in order from right to left.</dd>
 <dt id="none"><code>none</code></dt>
 <dd>Specifies that no transform should be applied.</dd>
</dl>

<h2 id="Accessibility_concerns">Accessibility concerns</h2>

<p>Scaling/zooming animations are problematic for accessibility, as they are a common trigger for certain types of migraine. If you need to include such animations on your website, you should provide a control to allow users to turn off animations, preferrably site-wide.</p>

<p>Also, consider making use of the {{cssxref("@media/prefers-reduced-motion", "prefers-reduced-motion")}} media feature — use it to write a <a href="/en-US/docs/Web/CSS/Media_Queries">media query</a> that will turn off animations if the user has reduced animation specified in their system preferences.</p>

<p>Find out more:</p>

<ul>
 <li><a href="/en-US/docs/Web/Accessibility/Understanding_WCAG/Operable#Guideline_2.3_%E2%80%94_Seizures_and_Physical_Reactions_Do_not_design_content_in_a_way_that_is_known_to_cause_seizures_or_physical_reactions">MDN Understanding WCAG, Guideline 2.3 explanations</a></li>
 <li><a href="https://www.w3.org/WAI/WCAG21/Understanding/animation-from-interactions">Understanding Success Criterion 2.3.3 | W3C Understanding WCAG 2.1</a></li>
</ul>

<h2 id="Formal_definition">Formal definition</h2>

<p>{{CSSInfo}}</p>

<h2 id="Formal_syntax">Formal syntax</h2>

<pre class="syntaxbox notranslate">{{csssyntax}}</pre>

<h2 id="Examples">Examples</h2>

<h3 id="Translating_and_rotating_an_element">Translating and rotating an element</h3>

<h4 id="HTML">HTML</h4>

<pre class="brush: html notranslate">&lt;div&gt;Transformed element&lt;/div&gt;</pre>

<h4 id="CSS">CSS</h4>

<pre class="brush: css notranslate">div {
  border: solid red;
  transform: translate(30px, 20px) rotate(20deg);
  width: 140px;
  height: 60px;
}</pre>

<h4 id="Result">Result</h4>

<p>{{EmbedLiveSample("Translating_and_rotating_an_element", "400", "160")}}</p>

<h3 id="More_examples">More examples</h3>

<p>Please see <a href="/en-US/docs/Web/Guide/CSS/Using_CSS_transforms">Using CSS transforms</a> and {{cssxref("&lt;transform-function&gt;")}} for more examples.</p>

<ul>
</ul>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{SpecName('CSS Transforms 2', '#transform-functions', 'transform')}}</td>
   <td>{{Spec2('CSS Transforms 2')}}</td>
   <td>Adds 3D transform functions.</td>
  </tr>
  <tr>
   <td>{{SpecName('CSS3 Transforms', '#transform-property', 'transform')}}</td>
   <td>{{Spec2('CSS3 Transforms')}}</td>
   <td>Initial definition.</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("css.properties.transform")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li><a href="/en-US/docs/CSS/Using_CSS_transforms">Using CSS transforms</a></li>
 <li>{{cssxref("&lt;transform-function&gt;")}} data type with all the transform functions explained.</li>
 <li>Online tool to visualize CSS Transform functions: <a href="https://css-transform.moro.es/">CSS Transform Playground</a></li>
</ul>
